"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var pact = require("@pact-foundation/pact");
var path = require("path");
var supertest = require("supertest");
exports.pactWith = function (options, tests) {
    return describe("Pact between " + options.consumer + " and " + options.provider, function () {
        var port = options.port || 8282;
        var pactMock = new pact.Pact(__assign({ port: port, log: path.resolve(process.cwd(), "pact/logs", options.consumer + "-" + options.provider + "-mockserver-integration.log"), dir: path.resolve(process.cwd(), "pact/pacts"), spec: 2, logLevel: options.logLevel || "error", pactfileWriteMode: "update" }, options));
        beforeAll(function () { return pactMock.setup(); });
        afterAll(function () { return pactMock.finalize(); });
        afterEach(function () { return pactMock.verify(); });
        tests(pactMock);
    });
};
exports.pactWithSuperTest = function (options, tests) {
    return describe("Pact between " + options.consumer + " and " + options.provider, function () {
        var port = options.port || 8989;
        var pactMock = new pact.Pact(__assign({ port: port, log: path.resolve(process.cwd(), "pact/logs", options.consumer + "-" + options.provider + "-mockserver-integration.log"), dir: path.resolve(process.cwd(), "pact/pacts"), spec: 2, logLevel: options.logLevel || "error", pactfileWriteMode: "update" }, options));
        beforeAll(function () { return pactMock.setup(); });
        afterAll(function () { return pactMock.finalize(); });
        afterEach(function () { return pactMock.verify(); });
        var client = getClient(port);
        tests(pactMock, client);
    });
};
var getClient = function (port) {
    var url = "http://localhost:" + port;
    return supertest(url);
};
